(define (l d) (load (string-append "D:\\Classes\\6.001 Structure and Interpretation of Computer Programs\\recitations\\" d)))
(l "objsys.scm") (l "objtypes.scm") (l "setup.scm")
(setup 'dalleyg)

(define (find-room room-name)
  (let ((matches (filter (lambda (room) (eq? room-name (ask room 'NAME)))
                         all-rooms)))
    (if matches (car matches) #f)))

;; ENCHANTED-PERSON

(define (create-enchanted-person name birthplace activity miserly incant action)
  (create-instance enchanted-person name birthplace activity miserly incant action))

(define (enchanted-person self name birthplace activity miserly incant action)
  (let ((auto-part (autonomous-person self name birthplace activity miserly))
        (spell-part (spell self name birthplace incant action)))
    (make-handler
     'enchanted-person
     (make-methods
      'HAVE-FIT
      (lambda () 
        (ask auto-part 'HAVE-FIT)
        (for-each (lambda (victim) (ask spell-part 'USE self victim))
                  (ask self 'PEOPLE-AROUND))))
     auto-part spell-part)))
      
(display "\n\nTESTING ENCHANTED-PERSON\n")

(define e-action (lambda (caster target)
                             (ask target 'EMIT
                                  (list (ask target 'NAME) "sighs"))))
;(define e-action (lambda (caster target) (set! health (+ health 10))))

(define e 
  (create-enchanted-person 'gandolf (ask me 'LOCATION) 5 1 
                           'zala-bugadee-boo e-action))
(ask e 'HAVE-FIT)
(newline) (display (list "GANDOLF is at " (ask (ask e 'LOCATION) 'NAME)))
(ask e 'MOVE-AND-TAKE-STUFF)
(newline) (display (list "GANDOLF is at " (ask (ask e 'LOCATION) 'NAME)))


; Run the clock for a while
;(run-clock 2)
