(define (l d) (load (string-append "D:\\Classes\\6.001 Structure and Interpretation of Computer Programs\\recitations\\" d)))
(l "objsys.scm") (l "objtypes.scm") (l "setup.scm")
(setup 'dalleyg)

(define (find-room room-name)
  (let ((matches (filter (lambda (room) (eq? room-name (ask room 'NAME)))
                         all-rooms)))
    (if matches (car matches) #f)))

;; MONK

(define (create-monk name birthplace)
  (create-instance monk name birthplace))

(define (monk self name birthplace)
  (let ((person-part (person self name birthplace)))
    (make-handler 
        'monk
        (make-methods
         'ADD-THING
         ;'TAKE
         (lambda (thing)
           (ask self 'SAY (list "Possessions are fleeting. I cannot take" 
                                (ask thing 'name))))
         )
        person-part)))  

(define my-monk (create-monk 'friar-tuck (find-room 'baker)))
(ask my-monk 'TAKE (pick-random (ask my-monk 'STUFF-AROUND)))
(ask my-monk 'GO-EXIT (random-exit (ask my-monk 'LOCATION)))

; Run the clock for a while
;(run-clock 2)
