(define (l d) (load (string-append "D:\\Classes\\6.001 Structure and Interpretation of Computer Programs\\recitations\\" d)))
(l "objsys.scm") (l "objtypes.scm") (l "setup.scm")
(setup 'dalleyg)

(define (find-room room-name)
  (let ((matches (filter (lambda (room) (eq? room-name (ask room 'NAME)))
                         all-rooms)))
    (if matches (car matches) #f)))

;; RECORDER

(define (create-recorder name birthplace)
  (create-instance recorder name birthplace))

(define (recorder self name birthplace)
  (let ((person-part (person self name birthplace))
        (recording '()))
    (make-handler 
     'recorder
     (make-methods
      'SAY 
      (lambda (list-of-stuff)
        (set! recording (cons list-of-stuff recording))
        (ask person-part 'SAY list-of-stuff))
      'REPLAY
      (lambda ()
        (ask person-part 'SAY (reverse recording))))
     person-part)))
  
(define polly (create-recorder 'polly (ask me 'LOCATION)))
(ask polly 'SAY '(Shiver me timbers))
(ask polly 'SAY (cons (ask polly 'NAME) '(want a cracker)))
(ask polly 'REPLAY)

; Run the clock for a while
;(run-clock 2)
